#define I87KCAN_API extern "C" __declspec(dllexport)

#define CAN87K_OK                    0
#define CAN87K_TIMEOUT              21
#define CAN87K_FIFO_EMPTY           22
#define CAN87K_FIFO_FULL            23
#define CAN87K_INIT_ERROR           24
#define CAN87K_PARATERS_ERROR       25
#define CAN87K_CAN_REG_ERROR        26

#define IDErr               1
#define DataLenErr          2
#define DataErr             3
#define CmdNotSupport       4
#define BaudRateErr         6
#define SetCANRegErr        7
#define NoData              8
#define RecWrongMsg         9
#define CANMsgTxFailure    10
#define HostCmdBufOverFlow 11
#define CommTimeOut        12

I87KCAN_API WORD I87KCANConfig(BYTE Ack, BYTE BufferSize);

I87KCAN_API WORD GetI87KCAN2Config(BYTE *Ack, BYTE *BufferSize);

I87KCAN_API WORD SetCANBaud(DWORD Baud, BYTE BT0, BYTE BT1);

I87KCAN_API WORD GetCANBaud(DWORD *Baud, BYTE *BT0, BYTE *BT1);

I87KCAN_API WORD SetCANMask(DWORD AccCode, DWORD AccMask);

I87KCAN_API WORD GetCANMask(DWORD *AccCode, DWORD *AccMask);

I87KCAN_API WORD ClearStatus(void);

I87KCAN_API WORD GetStatus(BYTE *CANReg, BYTE *OverflowFlag);

I87KCAN_API WORD ResetI87KCAN(void);

I87KCAN_API WORD I87KCANInit(DWORD CANBaud, BYTE BT0, BYTE BT1, DWORD CAN_AccCode, DWORD CAN_Mask, BYTE Ack, BYTE BufferSize);

I87KCAN_API WORD GetCANMsg(BYTE *Mode, DWORD *ID, BYTE *RTR, BYTE *DataLen, BYTE *Data);

I87KCAN_API WORD SendCANMsg(BYTE Mode,DWORD ID, BYTE RTR, BYTE DataLen, BYTE* Data);