// recmsgDlg.cpp : @
//

#include "stdafx.h"
#include "recmsg.h"
#include "recmsgDlg.h"

#include "..\..\87CANlib\ver_120\I87KCAN.h"
#include <XPacSDK_CE.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CrecmsgDlg ܤ

CrecmsgDlg::CrecmsgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CrecmsgDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CrecmsgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_OVERFLOW_STATIC, m_OverFlow);
	DDX_Control(pDX, IDC_STATUS_STATIC, m_CANStatus);
	DDX_Control(pDX, IDC_SLOT_COMBO, m_Slot);
	DDX_Control(pDX, IDC_RUN_BUTTON, m_Run);
	DDX_Control(pDX, IDC_Reset_BUTTON, m_Reset);
	DDX_Control(pDX, IDC_MSG_LIST_CTRL, m_MsgListCtrl);
	DDX_Control(pDX, IDC_INIT_BUTTON, m_Init);
	DDX_Control(pDX, IDC_BAUD_COMBO, m_Baud);
	DDX_Control(pDX, IDC_CLEAR_BUTTON, m_Clear);
}

BEGIN_MESSAGE_MAP(CrecmsgDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_CBN_SELENDOK(IDC_SLOT_COMBO, OnSelendokSlotCombo)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_Reset_BUTTON, OnResetBUTTON)
	ON_BN_CLICKED(IDC_CLEAR_BUTTON, OnClearButton)
	ON_BN_CLICKED(IDC_INIT_BUTTON, OnInitButton)
	ON_BN_CLICKED(IDC_RUN_BUTTON, OnRunButton)
END_MESSAGE_MAP()


// CrecmsgDlg TBz`

#define MAX_LINE 1000

WORD PortEnable,TimerEnable,MsgFormat,LineCnt;
BYTE OldCANReg=0,OldOverflogFlag;
BYTE OldSlotSelect;
HANDLE HPORT = NULL;

void CrecmsgDlg::FormInit(void)
{
	BOOL TempRet;
	//Initiate all objects and parameters used in the dialog
	m_Reset.EnableWindow(FALSE);
	m_Run.EnableWindow(FALSE);
	m_CANStatus.SetWindowText(_T("****"));
	if (TimerEnable) KillTimer(12345);
	TimerEnable=0;
	LineCnt=0;
	TempRet=uart_Close(HPORT);
	if (TempRet == FALSE) return;
	PortEnable=0;
}

BOOL CrecmsgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	
	// Initial Slot ComBo-Box
	m_Slot.AddString(_T("Slot 0"));
	m_Slot.AddString(_T("Slot 1"));
	m_Slot.AddString(_T("Slot 2"));
	m_Slot.AddString(_T("Slot 3"));
	m_Slot.AddString(_T("Slot 4"));
	m_Slot.AddString(_T("Slot 5"));
	m_Slot.AddString(_T("Slot 6"));
	m_Slot.AddString(_T("Slot 7"));

	// Initial Baudrate ComBo-Box
	m_Baud.AddString(_T("      5K bps"));
	m_Baud.AddString(_T("    10K bps"));
	m_Baud.AddString(_T("    20K bps"));
	m_Baud.AddString(_T("    25K bps"));
	m_Baud.AddString(_T("    50K bps"));
	m_Baud.AddString(_T("  100K bps"));
	m_Baud.AddString(_T("  125K bps"));
	m_Baud.AddString(_T("  200K bps"));
	m_Baud.AddString(_T("  250K bps"));
	m_Baud.AddString(_T("  500K bps"));
	m_Baud.AddString(_T("  800K bps"));
	m_Baud.AddString(_T("1000K bps"));
	m_Baud.AddString(_T("User-defined"));

	//initial button
	m_Reset.EnableWindow(FALSE);
	m_Run.EnableWindow(FALSE);
	m_CANStatus.SetWindowText(_T("****"));
	
	//initial button
	FormInit();
		
	//parameter initialize
	m_Slot.SetCurSel(0);
	OldSlotSelect=0;
	m_Baud.SetCurSel(11);

	//initiate list control object
	m_MsgListCtrl.InsertColumn(0,_T("NO."),LVCFMT_CENTER,34);
	m_MsgListCtrl.InsertColumn(1,_T("Mode"),LVCFMT_CENTER,42);
	m_MsgListCtrl.InsertColumn(2,_T("ID"),LVCFMT_CENTER,70);
	m_MsgListCtrl.InsertColumn(3,_T("RTR"),LVCFMT_CENTER,34);
	m_MsgListCtrl.InsertColumn(4,_T("L"),LVCFMT_CENTER,19);
	m_MsgListCtrl.InsertColumn(5,_T("D0"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(6,_T("D1"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(7,_T("D2"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(8,_T("D3"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(9,_T("D4"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(10,_T("D5"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(11,_T("D6"),LVCFMT_CENTER,35);
	m_MsgListCtrl.InsertColumn(12,_T("D7"),LVCFMT_CENTER,35);

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CrecmsgDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_RECMSG_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_RECMSG_DIALOG));
	}
}
#endif

void CrecmsgDlg::OnSelendokSlotCombo() 
{
	//Check if the slot combo box is changed or not, and do something for different situation
	if (m_Slot.GetCurSel()!=OldSlotSelect){
		FormInit();
		OldSlotSelect=m_Slot.GetCurSel();
		return;
	}
}

void CrecmsgDlg::OnTimer(UINT nIDEvent) 
{
	BYTE TempCANReg,TempOverflogFlag,Mode,RTR,DataLen,Data[8];
	wchar_t wTempStr[200];
	WORD Ret;
	DWORD ID;
	 
	//Get I-87120 status from I-87120 module
	Ret=GetStatus(OldSlotSelect,&TempCANReg,&TempOverflogFlag);
	if (Ret){
		FormInit();
		wsprintf(wTempStr,_T("Get Status Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}
	if (TempCANReg!=OldCANReg){
		wsprintf(wTempStr,_T("0x%02X"),TempCANReg);
		m_CANStatus.SetWindowText(wTempStr);
		OldCANReg=TempCANReg;
	}

	//Show the I-87120 status
	if (TempOverflogFlag!=OldOverflogFlag){
		wsprintf(wTempStr,_T("0x%02X"),TempCANReg);
		m_OverFlow.SetWindowText(wTempStr);
		OldOverflogFlag=TempOverflogFlag;
	}

	//Get CAN message from I-87120
	Ret=GetCANMsg(OldSlotSelect,&Mode,&ID,&RTR,&DataLen,Data);
	if (Ret){
		if (Ret==CAN87K_FIFO_EMPTY) return;
		FormInit();
		wsprintf(wTempStr,_T("Get Message Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	//Show the receive CAN message information in the list control object
	if (RTR){
		CString strText;
		strText.Format(_T("%03d"),LineCnt);
		m_MsgListCtrl.InsertItem(LineCnt,strText);
		m_MsgListCtrl.SetItemText(LineCnt,1,Mode?_T("2.0B"):_T("2.0A"));
		strText.Format(_T("%lX"),ID);
		m_MsgListCtrl.SetItemText(LineCnt,2, strText);
		m_MsgListCtrl.SetItemText(LineCnt,3, RTR?_T("Y"):_T("N"));
		strText.Format(_T("%d"),DataLen);
		m_MsgListCtrl.SetItemText(LineCnt,4, strText);
	}
	else{
		CString strText;
		strText.Format(_T("%03d"),LineCnt);
		m_MsgListCtrl.InsertItem(LineCnt,strText);
		m_MsgListCtrl.SetItemText(LineCnt,1,Mode?_T("2.0B"):_T("2.0A"));
		strText.Format(_T("%lX"),ID);
		m_MsgListCtrl.SetItemText(LineCnt,2, strText);
		m_MsgListCtrl.SetItemText(LineCnt,3, RTR?_T("Y"):_T("N"));
		strText.Format(_T("%d"),DataLen);
		m_MsgListCtrl.SetItemText(LineCnt,4, strText);
		for (int i=0;i<DataLen;i++){
			strText.Format(_T("%02X"),Data[i]);
			m_MsgListCtrl.SetItemText(LineCnt,5+i, strText);
		}
	}
	LineCnt++;
	if (LineCnt>5){
		CSize Rolling;
		Rolling.cx=0;
		Rolling.cy=30*(LineCnt-5);
		m_MsgListCtrl.Scroll(Rolling);
	}
	if (LineCnt==MAX_LINE){
		m_MsgListCtrl.DeleteAllItems( ); 
		LineCnt=0;
	}

	CDialog::OnTimer(nIDEvent);
}

void CrecmsgDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	//recover the timer setting and COM 0 setting
	if (TimerEnable) KillTimer(12345);
	if (PortEnable) uart_Close(HPORT);
}

void CrecmsgDlg::OnResetBUTTON() 
{
	//Send command to reset the I-87KCAN module
	WORD Ret;
	wchar_t wTempStr[200];
	Ret=ResetI87KCAN(OldSlotSelect);
	if (Ret){
		FormInit();
		wsprintf(wTempStr,_T("Get Status Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}
}

void CrecmsgDlg::OnClearButton() 
{
	//Clear all information stored in the list control object
	m_MsgListCtrl.DeleteAllItems( ); 
	LineCnt=0;
}

void CrecmsgDlg::OnInitButton() 
{
	wchar_t wTempStr[100];
	BYTE TempBt0=0,TempBt1=0;
	WORD Ret;
	CString TempStr;
	DWORD BaudMap[]={5000UL,10000UL,20000UL,25000UL,50000UL,100000UL,125000UL,
				     20000UL,250000UL,500000UL,800000UL,1000000UL};
	
	// Open Com0 For All I-87K Module
	HPORT = uart_Open("");	// COM0,115200,N,8,1
	if(HPORT == INVALID_HANDLE_VALUE){
		FormInit();
		wsprintf(wTempStr,_T("Open Com0 Error"));
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	PortEnable=1;

	//Select the slot where the I-87120 is plugged.
	//ChangeSlotTo87K(m_Slot.GetCurSel());
	OldSlotSelect = m_Slot.GetCurSel();

	//configue the I-87KCAN setting and initiate the I-87120
	Ret=I87KCANInit(OldSlotSelect,HPORT,BaudMap[m_Baud.GetCurSel()],0,0,0x00000000UL,0xffffffffUL,0,0);
	if (Ret){
	
		wsprintf(wTempStr,_T("Initiate I-87KCAN Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	//start the objects and parameters used in the dialog
	m_Reset.EnableWindow(TRUE);
	m_Run.EnableWindow(TRUE);
	m_CANStatus.SetWindowText(_T("0x0C"));
	m_OverFlow.SetWindowText(_T("0x00"));
	if (!TimerEnable) SetTimer(12345,1,NULL);
	TimerEnable=1;
}

void CrecmsgDlg::OnRunButton() 
{
	//Let the tiemr stop or continue
	if (TimerEnable){
		m_Run.SetWindowText(_T("Go"));
		KillTimer(12345);
		TimerEnable=0;
	}
	else{
		m_Run.SetWindowText(_T("Pause"));
		SetTimer(12345,1,NULL);
		TimerEnable=1;
	}
}

