///////////////////////////////////////////////////////////////
//            I-87120 firmware for user design               //
///////////////////////////////////////////////////////////////
#include "c87s110.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
                                          
void UserIrqFunc(char INTT)               
{
  //  If CPU is interrupted by the CAN controller, the function will be excuted
  if (INTT);  
}

void UserInitFunc(void)
{
  //  The function will be excuted first after I-87120 is power on
}

void UserDefCmdFunc(unsigned int CmdLength, char * UserCmd)
{
  // Process user-defined command, the UserCmd[0] must be '_' 
  if (CmdLength);
  switch (UserCmd[1]){
  }
}

void UserDefBinaryFunc(unsigned int CmdLength, char * UserCmd)
{
  // Process user-defined command for binary code, the UserCmd[0] must be '|' 
  if (CmdLength);
  switch (UserCmd[1]){
  }
}

void UserLoopFunc(void)   
{
  // The function will be excuted in while loop after the I-87120 has be configured
}
