#define I87KCAN_API extern "C" __declspec(dllexport)

#define CAN87K_OK                    0
#define CAN87K_TIMEOUT              21
#define CAN87K_FIFO_EMPTY           22
#define CAN87K_FIFO_FULL            23
#define CAN87K_INIT_ERROR           24
#define CAN87K_PARATERS_ERROR       25
#define CAN87K_CAN_REG_ERROR        26

I87KCAN_API int I87KCANConfig(BYTE Ack, BYTE BufferSize);

I87KCAN_API int GetI87KCAN2Config(BYTE *Ack, BYTE *BufferSize);

I87KCAN_API int SetCANBaud(DWORD Baud, BYTE BT0, BYTE BT1);

I87KCAN_API int GetCANBaud(DWORD *Baud, BYTE *BT0, BYTE *BT1);

I87KCAN_API int SetCANMask(DWORD AccCode, DWORD AccMask);

I87KCAN_API int GetCANMask(DWORD *AccCode, DWORD *AccMask);

I87KCAN_API int ClearStatus(void);

I87KCAN_API int GetStatus(BYTE *CANReg, BYTE *OverflowFlag);

I87KCAN_API int ResetI87KCAN(void);

I87KCAN_API int I87KCANInit(DWORD CANBaud, BYTE BT0, BYTE BT1, DWORD CAN_AccCode, DWORD CAN_Mask, BYTE Ack, BYTE BufferSize);

I87KCAN_API int GetCANMsg(BYTE *Mode, DWORD *MsgID, BYTE *RTR, BYTE *DataLen, BYTE *Data);

I87KCAN_API int SendCANMsg(BYTE Mode,DWORD MsgID, BYTE RTR, BYTE DataLen, BYTE* Data);

I87KCAN_API int SendCmdStr(BYTE HintChar, char *SendString);

I87KCAN_API int SendCmdBufn(BYTE HintChar, char *TempBuf, WORD CharNum);

I87KCAN_API int SendRecCmdStr(char *CmdStr, char *RecBuf);